/*
 * Created on May 16, 2005
 */
package com.sunlabs.archsim.build;

import java.util.Set;
import java.util.HashSet;

import com.sunlabs.archsim.base.common.Parameters;

/**
 *
 * Copyright  2005 Sun Microsystems Inc. All rights reserved. Use is subject to license terms.
 * 
 * @author ib27688
 *
 * A record of a connection between components.
 * This connection corresponds to the concept of the state in
 * the GasP model.
 *
 */
public class ConnectionRecord {

	/** connection name */
	public String name;
	
	/** is the data state active active? */
	boolean dataActive;
	
	/** initial value if the connection is initially active */
	public String dataValue;
	
	/** parameters for the connection */
	public Parameters attributes=new Parameters();
	
	/** source line where the connection is defined */
	public int line;

	/** source connection points */
	public Set<ConnectionPoint> sources;
	/** destination connection points */
	public Set<ConnectionPoint> destinations;
	
	public ConnectionRecord() {
		name= null;

		sources= new HashSet<ConnectionPoint>();
		destinations= new HashSet<ConnectionPoint>();
		
		dataActive= false;
		dataValue= null;
		
	} // ConnectionRecord constructor 
	
	public String toString() {
		String result= "Connection record:\n"
			+ " name = " + name + "\n"
			+ "dataActive= " + dataActive + "\n"
			+ "dataValue= " + dataValue + "\n"
			+ "sources= " + sources + "\n" 
			+ "destinations=" + destinations;
		
		if (attributes != null) {
			result+= "attributes= " + attributes.toString() + "\n";
		}
		else {
			result+= "attributes= null\n";
		}
		
		return result;
	}
	
	
} // class Connection record
