package com.sunlabs.archsim.fleet.codeStorage;

import java.util.Collection;
import java.util.Iterator;
import java.util.LinkedList;

import com.sunlabs.archsim.fleet.common.Payload;

/**
 *
 * Copyright  2005 Sun Microsystems Inc. All rights reserved. Use is subject to license terms.
 * 
 * 
 * @author ib27688
 *
 * A bag of instructions. Each instruction is represented by a payload object. 
 * 
 */

public class CodeBag {
	
	protected String name;
	
	protected Collection<Payload> myInstructions;
	
	public CodeBag(String n) {
		name= n;
		myInstructions= new LinkedList<Payload>();
	} // CodeBag constructor
	
	public void addInstruction(Payload i) {
		myInstructions.add(i);
	}
	
	public void addInstructions(Collection<Payload> l) {
		myInstructions.addAll(l);
	}
	
	public String getName() {
		return name;
	}
	
	public Iterator<Payload> iterator() {
		return myInstructions.iterator();
	}
	
	public Collection<Payload> instructions() {
		return myInstructions;
	}
	
	public String toString() {
		String bagString= "Code bag " + name + ":";
		for (Payload p: myInstructions) {
			bagString= bagString + "\n" + p.toString();
		}
		return bagString;
	}
	
} // class CodeBag
